<?php

namespace Modules\Refund\Requests\Api;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Order\Services\CartService;
use Modules\Order\Services\OrderService;
use Modules\Refund\Services\RefundService;
use Modules\User\Services\AccountService;

class ShowRequest extends FormRequest
{
    public function __construct(
        private RefundService $refundService,
        private AccountService $accountService,
    ){}

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $account = $this->accountService->getAccount();
        $refund = $this->refundService->getItem($this->id);
        $rules = [];
        if (!$refund )
        {
            return
                [
                    'not_exist' => 'required'
                ];
        }
        if($refund->order->user_id != $account['user']->id)
        {
            return
                [
                    'not_exist' => 'required'
                ];
        }
        return $rules;
    }

    public function messages()
    {
        return [
            'over_count.required' => __('web.over_count'),
            'not_exist.required' => __('web.not_exist')
        ];
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'product_id' => __('web.product_id'),
            'count' => __('web.count'),
            'option_id' => __('web.option'),
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param  \Illuminate\Contracts\Validation\Validator  $validator
     * @return void
     *
     * @throws \Illuminate\Validation\ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        $errors = (new ValidationException($validator))->errors();
        $message = $validator->errors()->first();
        throw new HttpResponseException(response()->json(['message'=> $message, 'errors' => $errors],  400));

    }
}
